--[[
			(True) Adaptive User Interface
			
			To the extent possible under law, Matthew D. Lee has
			waived all copyright and related or neighboring rights to the 
			(True) Adaptive User Interface.  This work is published from the
			United States of America and is considered Public Domain.
			
			Share and share a like.
]]

--[[
			Register True Core
]]

TRUESYS = RegisterVFLModule({
	name = "TRUESYS";
	title = "True Core";
	description = "True Core";
	parent = RDX;
});

TRUESYS:LoadVersionFromTOC("TrueAui");

VFLP.RegisterCategory("TRUESYS: Core");

-- Get Version
function TRUESYS.GetVersion()
	return TRUESYS.version[1] .. "." .. TRUESYS.version[2] .. "." .. TRUESYS.version[3];
end

-- Make my life easier.
function TRUESYS.Addonpath(path)
	location = "Interface\\AddOns\\TrueAui\\";
	if not path then
		return location
	else
		return location .. path .. "\\"
	end
end

--[[
			Register an RDX function (until the RDX is updated outside of Git)
]]
			
-- Given a spell's full name and Booktype (BOOKTYPE_SPELL or BOOKTYPE_PET), return spell's book numerical ID.
function RDXSS.GetSpellBookId(sname, bkt)
	if not sname then return nil; end
	if not bkt then return nil; end
	for i = 1, MAX_SKILLLINE_TABS do
		local name, texture, offset, numSpells = GetSpellTabInfo(i);
		if not name then break; end
		for s = offset + 1, offset + numSpells do
			if (sname == GetSpellBookItemName(s,bkt)) then
				return s;
			end
		end
	end
	return 0;
end